diff --git a/contrib/hstore/hstore_io.c b/contrib/hstore/hstore_io.c
new file mode 100644
index 1cecf86..afd14d4
*** a/contrib/hstore/hstore_io.c
--- b/contrib/hstore/hstore_io.c
*************** hstore_from_record(PG_FUNCTION_ARGS)
*** 839,844 ****
--- 839,845 ----
  		ItemPointerSetInvalid(&(tuple.t_self));
  		tuple.t_tableOid = InvalidOid;
  		tuple.t_data = rec;
+ 		HeapTupleSetZeroBase(&tuple);
  
  		values = (Datum *) palloc(ncolumns * sizeof(Datum));
  		nulls = (bool *) palloc(ncolumns * sizeof(bool));
*************** hstore_populate_record(PG_FUNCTION_ARGS)
*** 984,989 ****
--- 985,991 ----
  		ItemPointerSetInvalid(&(tuple.t_self));
  		tuple.t_tableOid = InvalidOid;
  		tuple.t_data = rec;
+ 		HeapTupleSetZeroBase(&tuple);
  	}
  
  	/*
diff --git a/contrib/pageinspect/btreefuncs.c b/contrib/pageinspect/btreefuncs.c
new file mode 100644
index 02440ec..8c4d0ff
*** a/contrib/pageinspect/btreefuncs.c
--- b/contrib/pageinspect/btreefuncs.c
*************** bt_page_stats(PG_FUNCTION_ARGS)
*** 225,231 ****
  	values[j++] = psprintf("%d", stat.free_size);
  	values[j++] = psprintf("%d", stat.btpo_prev);
  	values[j++] = psprintf("%d", stat.btpo_next);
! 	values[j++] = psprintf("%d", (stat.type == 'd') ? stat.btpo.xact : stat.btpo.level);
  	values[j++] = psprintf("%d", stat.btpo_flags);
  
  	tuple = BuildTupleFromCStrings(TupleDescGetAttInMetadata(tupleDesc),
--- 225,234 ----
  	values[j++] = psprintf("%d", stat.free_size);
  	values[j++] = psprintf("%d", stat.btpo_prev);
  	values[j++] = psprintf("%d", stat.btpo_next);
! 	if (stat.type == 'd')
! 		values[j++] = psprintf(XID_FMT, stat.btpo.xact);
! 	else
! 		values[j++] = psprintf("%d", stat.btpo.level);
  	values[j++] = psprintf("%d", stat.btpo_flags);
  
  	tuple = BuildTupleFromCStrings(TupleDescGetAttInMetadata(tupleDesc),
diff --git a/contrib/pageinspect/heapfuncs.c b/contrib/pageinspect/heapfuncs.c
new file mode 100644
index 1448eff..698e646
*** a/contrib/pageinspect/heapfuncs.c
--- b/contrib/pageinspect/heapfuncs.c
*************** heap_page_items(PG_FUNCTION_ARGS)
*** 194,199 ****
--- 194,200 ----
  			lp_offset == MAXALIGN(lp_offset) &&
  			lp_offset + lp_len <= raw_page_size)
  		{
+ 			HeapTupleData	tup;
  			HeapTupleHeader tuphdr;
  			bytea	   *tuple_data_bytea;
  			int			tuple_data_len;
*************** heap_page_items(PG_FUNCTION_ARGS)
*** 201,209 ****
  			/* Extract information from the tuple header */
  
  			tuphdr = (HeapTupleHeader) PageGetItem(page, id);
  
! 			values[4] = UInt32GetDatum(HeapTupleHeaderGetRawXmin(tuphdr));
! 			values[5] = UInt32GetDatum(HeapTupleHeaderGetRawXmax(tuphdr));
  			/* shared with xvac */
  			values[6] = UInt32GetDatum(HeapTupleHeaderGetRawCommandId(tuphdr));
  			values[7] = PointerGetDatum(&tuphdr->t_ctid);
--- 202,212 ----
  			/* Extract information from the tuple header */
  
  			tuphdr = (HeapTupleHeader) PageGetItem(page, id);
+ 			tup.t_data = tuphdr;
+ 			HeapTupleCopyBaseFromPage(&tup, page);
  
! 			values[4] = TransactionIdGetDatum(HeapTupleGetXmin(&tup));
! 			values[5] = TransactionIdGetDatum(HeapTupleGetRawXmax(&tup));
  			/* shared with xvac */
  			values[6] = UInt32GetDatum(HeapTupleHeaderGetRawCommandId(tuphdr));
  			values[7] = PointerGetDatum(&tuphdr->t_ctid);
diff --git a/contrib/pageinspect/pageinspect--1.5.sql b/contrib/pageinspect/pageinspect--1.5.sql
new file mode 100644
index 1e40c3c..fdbd299
*** a/contrib/pageinspect/pageinspect--1.5.sql
--- b/contrib/pageinspect/pageinspect--1.5.sql
*************** CREATE FUNCTION page_header(IN page byte
*** 28,33 ****
--- 28,35 ----
      OUT special smallint,
      OUT pagesize smallint,
      OUT version smallint,
+     OUT xid_base xid,
+     OUT multi_base xid,
      OUT prune_xid xid)
  AS 'MODULE_PATHNAME', 'page_header'
  LANGUAGE C STRICT PARALLEL SAFE;
diff --git a/contrib/pageinspect/rawpage.c b/contrib/pageinspect/rawpage.c
new file mode 100644
index dff11f2..68eebcb
*** a/contrib/pageinspect/rawpage.c
--- b/contrib/pageinspect/rawpage.c
***************
*** 18,23 ****
--- 18,24 ----
  #include "pageinspect.h"
  
  #include "access/htup_details.h"
+ #include "commands/sequence.h"
  #include "catalog/catalog.h"
  #include "catalog/namespace.h"
  #include "catalog/pg_type.h"
*************** page_header(PG_FUNCTION_ARGS)
*** 220,227 ****
  
  	Datum		result;
  	HeapTuple	tuple;
! 	Datum		values[9];
! 	bool		nulls[9];
  
  	PageHeader	page;
  	XLogRecPtr	lsn;
--- 221,228 ----
  
  	Datum		result;
  	HeapTuple	tuple;
! 	Datum		values[11];
! 	bool		nulls[11];
  
  	PageHeader	page;
  	XLogRecPtr	lsn;
*************** page_header(PG_FUNCTION_ARGS)
*** 270,292 ****
  	values[5] = UInt16GetDatum(page->pd_special);
  	values[6] = UInt16GetDatum(PageGetPageSize(page));
  	values[7] = UInt16GetDatum(PageGetPageLayoutVersion(page));
  	if (PageGetSpecialSize(page) == MAXALIGN(sizeof(HeapPageSpecialData)))
  	{
! 		HeapPageSpecial	pageSpecial = HeapPageGetSpecial(page);
  		if (pageSpecial->pd_magic == HEAP_PAGE_MAGIC ||
  			pageSpecial->pd_magic == SEQ_PAGE_MAGIC)
  		{
! 			values[8] = TransactionIdGetDatum(pageSpecial->pd_prune_xid);
  			nulls[8] = false;
  		}
  		else
  		{
  			nulls[8] = true;
  		}
  	}
  	else
  	{
  		nulls[8] = true;
  	}
  
  	/* Build and return the tuple. */
--- 271,302 ----
  	values[5] = UInt16GetDatum(page->pd_special);
  	values[6] = UInt16GetDatum(PageGetPageSize(page));
  	values[7] = UInt16GetDatum(PageGetPageLayoutVersion(page));
+ 
  	if (PageGetSpecialSize(page) == MAXALIGN(sizeof(HeapPageSpecialData)))
  	{
! 		HeapPageSpecial pageSpecial = HeapPageGetSpecial(page);
  		if (pageSpecial->pd_magic == HEAP_PAGE_MAGIC ||
  			pageSpecial->pd_magic == SEQ_PAGE_MAGIC)
  		{
! 			values[8] = TransactionIdGetDatum(pageSpecial->pd_xid_base);
! 			values[9] = TransactionIdGetDatum(pageSpecial->pd_multi_base);
! 			values[10] = TransactionIdGetDatum(HeapPageGetPruneXid(page));
  			nulls[8] = false;
+ 			nulls[9] = false;
+ 			nulls[10] = false;
  		}
  		else
  		{
  			nulls[8] = true;
+ 			nulls[9] = true;
+ 			nulls[10] = true;
  		}
  	}
  	else
  	{
  		nulls[8] = true;
+ 		nulls[9] = true;
+ 		nulls[10] = true;
  	}
  
  	/* Build and return the tuple. */
diff --git a/contrib/pg_visibility/pg_visibility.c b/contrib/pg_visibility/pg_visibility.c
new file mode 100644
index 480f917..905f9cf
*** a/contrib/pg_visibility/pg_visibility.c
--- b/contrib/pg_visibility/pg_visibility.c
*************** tuple_all_visible(HeapTuple tup, Transac
*** 755,761 ****
  	 * be set here.  So just check the xmin.
  	 */
  
! 	xmin = HeapTupleHeaderGetXmin(tup->t_data);
  	if (!TransactionIdPrecedes(xmin, OldestXmin))
  		return false;			/* xmin not old enough for all to see */
  
--- 755,761 ----
  	 * be set here.  So just check the xmin.
  	 */
  
! 	xmin = HeapTupleGetXmin(tup);
  	if (!TransactionIdPrecedes(xmin, OldestXmin))
  		return false;			/* xmin not old enough for all to see */
  
diff --git a/contrib/pgrowlocks/pgrowlocks.c b/contrib/pgrowlocks/pgrowlocks.c
new file mode 100644
index 00e2015..d8e61a3
*** a/contrib/pgrowlocks/pgrowlocks.c
--- b/contrib/pgrowlocks/pgrowlocks.c
*************** pgrowlocks(PG_FUNCTION_ARGS)
*** 140,146 ****
  		htsu = HeapTupleSatisfiesUpdate(tuple,
  										GetCurrentCommandId(false),
  										scan->rs_cbuf);
! 		xmax = HeapTupleHeaderGetRawXmax(tuple->t_data);
  		infomask = tuple->t_data->t_infomask;
  
  		/*
--- 140,146 ----
  		htsu = HeapTupleSatisfiesUpdate(tuple,
  										GetCurrentCommandId(false),
  										scan->rs_cbuf);
! 		xmax = HeapTupleGetRawXmax(tuple);
  		infomask = tuple->t_data->t_infomask;
  
  		/*
*************** pgrowlocks(PG_FUNCTION_ARGS)
*** 156,162 ****
  											PointerGetDatum(&tuple->t_self));
  
  			values[Atnum_xmax] = palloc(NCHARS * sizeof(char));
! 			snprintf(values[Atnum_xmax], NCHARS, "%d", xmax);
  			if (infomask & HEAP_XMAX_IS_MULTI)
  			{
  				MultiXactMember *members;
--- 156,162 ----
  											PointerGetDatum(&tuple->t_self));
  
  			values[Atnum_xmax] = palloc(NCHARS * sizeof(char));
! 			snprintf(values[Atnum_xmax], NCHARS, XID_FMT, xmax);
  			if (infomask & HEAP_XMAX_IS_MULTI)
  			{
  				MultiXactMember *members;
*************** pgrowlocks(PG_FUNCTION_ARGS)
*** 197,203 ****
  							strcat(values[Atnum_modes], ",");
  							strcat(values[Atnum_pids], ",");
  						}
! 						snprintf(buf, NCHARS, "%d", members[j].xid);
  						strcat(values[Atnum_xids], buf);
  						switch (members[j].status)
  						{
--- 197,203 ----
  							strcat(values[Atnum_modes], ",");
  							strcat(values[Atnum_pids], ",");
  						}
! 						snprintf(buf, NCHARS, XID_FMT, members[j].xid);
  						strcat(values[Atnum_xids], buf);
  						switch (members[j].status)
  						{
*************** pgrowlocks(PG_FUNCTION_ARGS)
*** 238,244 ****
  				values[Atnum_ismulti] = pstrdup("false");
  
  				values[Atnum_xids] = palloc(NCHARS * sizeof(char));
! 				snprintf(values[Atnum_xids], NCHARS, "{%d}", xmax);
  
  				values[Atnum_modes] = palloc(NCHARS);
  				if (infomask & HEAP_XMAX_LOCK_ONLY)
--- 238,244 ----
  				values[Atnum_ismulti] = pstrdup("false");
  
  				values[Atnum_xids] = palloc(NCHARS * sizeof(char));
! 				snprintf(values[Atnum_xids], NCHARS, "{" XID_FMT "}", xmax);
  
  				values[Atnum_modes] = palloc(NCHARS);
  				if (infomask & HEAP_XMAX_LOCK_ONLY)
diff --git a/contrib/pgstattuple/pgstatapprox.c b/contrib/pgstattuple/pgstatapprox.c
new file mode 100644
index 9facf65..6f39aac
*** a/contrib/pgstattuple/pgstatapprox.c
--- b/contrib/pgstattuple/pgstatapprox.c
*************** statapprox_heap(Relation rel, output_typ
*** 151,156 ****
--- 151,157 ----
  			tuple.t_data = (HeapTupleHeader) PageGetItem(page, itemid);
  			tuple.t_len = ItemIdGetLength(itemid);
  			tuple.t_tableOid = RelationGetRelid(rel);
+ 			HeapTupleCopyBaseFromPage(&tuple, page);
  
  			/*
  			 * We count live and dead tuples, but we also need to add up
diff --git a/contrib/postgres_fdw/postgres_fdw.c b/contrib/postgres_fdw/postgres_fdw.c
new file mode 100644
index 080cb0a..e145284
*** a/contrib/postgres_fdw/postgres_fdw.c
--- b/contrib/postgres_fdw/postgres_fdw.c
*************** make_tuple_from_result_row(PGresult *res
*** 5050,5055 ****
--- 5050,5056 ----
  	 */
  	if (ctid)
  		tuple->t_self = tuple->t_data->t_ctid = *ctid;
+ 	HeapTupleSetZeroBase(tuple);
  
  	/*
  	 * Stomp on the xmin, xmax, and cmin fields from the tuple created by
*************** make_tuple_from_result_row(PGresult *res
*** 5059,5066 ****
  	 * assumption.  If we don't do this then, for example, the tuple length
  	 * ends up in the xmin field, which isn't what we want.
  	 */
! 	HeapTupleHeaderSetXmax(tuple->t_data, InvalidTransactionId);
! 	HeapTupleHeaderSetXmin(tuple->t_data, InvalidTransactionId);
  	HeapTupleHeaderSetCmin(tuple->t_data, InvalidTransactionId);
  
  	/*
--- 5060,5067 ----
  	 * assumption.  If we don't do this then, for example, the tuple length
  	 * ends up in the xmin field, which isn't what we want.
  	 */
! 	HeapTupleSetXmax(tuple, InvalidTransactionId);
! 	HeapTupleSetXmin(tuple, InvalidTransactionId);
  	HeapTupleHeaderSetCmin(tuple->t_data, InvalidTransactionId);
  
  	/*
diff --git a/contrib/test_decoding/test_decoding.c b/contrib/test_decoding/test_decoding.c
new file mode 100644
index 21cfd67..462812f
*** a/contrib/test_decoding/test_decoding.c
--- b/contrib/test_decoding/test_decoding.c
*************** pg_output_begin(LogicalDecodingContext *
*** 215,221 ****
  {
  	OutputPluginPrepareWrite(ctx, last_write);
  	if (data->include_xids)
! 		appendStringInfo(ctx->out, "BEGIN %u", txn->xid);
  	else
  		appendStringInfoString(ctx->out, "BEGIN");
  	OutputPluginWrite(ctx, last_write);
--- 215,221 ----
  {
  	OutputPluginPrepareWrite(ctx, last_write);
  	if (data->include_xids)
! 		appendStringInfo(ctx->out, "BEGIN " XID_FMT, txn->xid);
  	else
  		appendStringInfoString(ctx->out, "BEGIN");
  	OutputPluginWrite(ctx, last_write);
*************** pg_decode_commit_txn(LogicalDecodingCont
*** 233,239 ****
  
  	OutputPluginPrepareWrite(ctx, true);
  	if (data->include_xids)
! 		appendStringInfo(ctx->out, "COMMIT %u", txn->xid);
  	else
  		appendStringInfoString(ctx->out, "COMMIT");
  
--- 233,239 ----
  
  	OutputPluginPrepareWrite(ctx, true);
  	if (data->include_xids)
! 		appendStringInfo(ctx->out, "COMMIT " XID_FMT, txn->xid);
  	else
  		appendStringInfoString(ctx->out, "COMMIT");
  
diff --git a/doc/src/sgml/catalogs.sgml b/doc/src/sgml/catalogs.sgml
new file mode 100644
index ea655a1..88291d4
*** a/doc/src/sgml/catalogs.sgml
--- b/doc/src/sgml/catalogs.sgml
*************** SCRAM-SHA-256$<replaceable>&lt;iteration
*** 1921,1928 ****
        <entry>
         All transaction IDs before this one have been replaced with a permanent
         (<quote>frozen</>) transaction ID in this table.  This is used to track
!        whether the table needs to be vacuumed in order to prevent transaction
!        ID wraparound or to allow <literal>pg_xact</> to be shrunk.  Zero
         (<symbol>InvalidTransactionId</symbol>) if the relation is not a table.
        </entry>
       </row>
--- 1921,1928 ----
        <entry>
         All transaction IDs before this one have been replaced with a permanent
         (<quote>frozen</>) transaction ID in this table.  This is used to track
!        whether the table needs to be vacuumed in order to allow
!        <literal>pg_xact</> to be shrunk.  Zero
         (<symbol>InvalidTransactionId</symbol>) if the relation is not a table.
        </entry>
       </row>
*************** SCRAM-SHA-256$<replaceable>&lt;iteration
*** 1934,1941 ****
        <entry>
         All multixact IDs before this one have been replaced by a
         transaction ID in this table.  This is used to track
!        whether the table needs to be vacuumed in order to prevent multixact ID
!        wraparound or to allow <literal>pg_multixact</> to be shrunk.  Zero
         (<symbol>InvalidMultiXactId</symbol>) if the relation is not a table.
        </entry>
       </row>
--- 1934,1941 ----
        <entry>
         All multixact IDs before this one have been replaced by a
         transaction ID in this table.  This is used to track
!        whether the table needs to be vacuumed in order to allow
!        <literal>pg_multixact</> to be shrunk.  Zero
         (<symbol>InvalidMultiXactId</symbol>) if the relation is not a table.
        </entry>
       </row>
*************** SCRAM-SHA-256$<replaceable>&lt;iteration
*** 2617,2624 ****
        <entry>
         All transaction IDs before this one have been replaced with a permanent
         (<quote>frozen</>) transaction ID in this database.  This is used to
!        track whether the database needs to be vacuumed in order to prevent
!        transaction ID wraparound or to allow <literal>pg_xact</> to be shrunk.
         It is the minimum of the per-table
         <structname>pg_class</>.<structfield>relfrozenxid</> values.
        </entry>
--- 2617,2624 ----
        <entry>
         All transaction IDs before this one have been replaced with a permanent
         (<quote>frozen</>) transaction ID in this database.  This is used to
!        track whether the database needs to be vacuumed in order to allow
!        <literal>pg_xact</> to be shrunk.
         It is the minimum of the per-table
         <structname>pg_class</>.<structfield>relfrozenxid</> values.
        </entry>
*************** SCRAM-SHA-256$<replaceable>&lt;iteration
*** 2631,2638 ****
        <entry>
         All multixact IDs before this one have been replaced with a
         transaction ID in this database.  This is used to
!        track whether the database needs to be vacuumed in order to prevent
!        multixact ID wraparound or to allow <literal>pg_multixact</> to be shrunk.
         It is the minimum of the per-table
         <structname>pg_class</>.<structfield>relminmxid</> values.
        </entry>
--- 2631,2638 ----
        <entry>
         All multixact IDs before this one have been replaced with a
         transaction ID in this database.  This is used to
!        track whether the database needs to be vacuumed in order to allow
!        <literal>pg_multixact</> to be shrunk.
         It is the minimum of the per-table
         <structname>pg_class</>.<structfield>relminmxid</> values.
        </entry>
diff --git a/doc/src/sgml/config.sgml b/doc/src/sgml/config.sgml
new file mode 100644
index 0b943f4..16a501b
*** a/doc/src/sgml/config.sgml
--- b/doc/src/sgml/config.sgml
*************** include_dir 'conf.d'
*** 2136,2142 ****
           <literal>1min</>) are only allowed because they may sometimes be
           useful for testing.  While a setting as high as <literal>60d</> is
           allowed, please note that in many workloads extreme bloat or
!          transaction ID wraparound may occur in much shorter time frames.
          </para>
  
          <para>
--- 2136,2143 ----
           <literal>1min</>) are only allowed because they may sometimes be
           useful for testing.  While a setting as high as <literal>60d</> is
           allowed, please note that in many workloads extreme bloat or
!          page-level transaction ID wraparound may occur in much shorter time
!          frames.
          </para>
  
          <para>
*************** ANY <replaceable class="parameter">num_s
*** 3172,3178 ****
       </varlistentry>
  
       <varlistentry id="guc-vacuum-defer-cleanup-age" xreflabel="vacuum_defer_cleanup_age">
!       <term><varname>vacuum_defer_cleanup_age</varname> (<type>integer</type>)
        <indexterm>
         <primary><varname>vacuum_defer_cleanup_age</> configuration parameter</primary>
        </indexterm>
--- 3173,3179 ----
       </varlistentry>
  
       <varlistentry id="guc-vacuum-defer-cleanup-age" xreflabel="vacuum_defer_cleanup_age">
!       <term><varname>vacuum_defer_cleanup_age</varname> (<type>integer 64</type>)
        <indexterm>
         <primary><varname>vacuum_defer_cleanup_age</> configuration parameter</primary>
        </indexterm>
*************** COPY postgres_log FROM '/full/path/to/lo
*** 5869,5876 ****
         </para>
         <para>
          Note that even when this parameter is disabled, the system
!         will launch autovacuum processes if necessary to
!         prevent transaction ID wraparound.  See <xref
          linkend="vacuum-for-wraparound"> for more information.
         </para>
        </listitem>
--- 5870,5877 ----
         </para>
         <para>
          Note that even when this parameter is disabled, the system
!         will launch autovacuum processes if necessary to shrink
!         <literal>pg_clog</> and <literal>pg_multixact</>.  See <xref
          linkend="vacuum-for-wraparound"> for more information.
         </para>
        </listitem>
*************** COPY postgres_log FROM '/full/path/to/lo
*** 6014,6020 ****
       </varlistentry>
  
       <varlistentry id="guc-autovacuum-freeze-max-age" xreflabel="autovacuum_freeze_max_age">
!       <term><varname>autovacuum_freeze_max_age</varname> (<type>integer</type>)
        <indexterm>
         <primary><varname>autovacuum_freeze_max_age</> configuration parameter</primary>
        </indexterm>
--- 6015,6021 ----
       </varlistentry>
  
       <varlistentry id="guc-autovacuum-freeze-max-age" xreflabel="autovacuum_freeze_max_age">
!       <term><varname>autovacuum_freeze_max_age</varname> (<type>integer 64</type>)
        <indexterm>
         <primary><varname>autovacuum_freeze_max_age</> configuration parameter</primary>
        </indexterm>
*************** COPY postgres_log FROM '/full/path/to/lo
*** 6024,6038 ****
          Specifies the maximum age (in transactions) that a table's
          <structname>pg_class</>.<structfield>relfrozenxid</> field can
          attain before a <command>VACUUM</> operation is forced
!         to prevent transaction ID wraparound within the table.
!         Note that the system will launch autovacuum processes to
!         prevent wraparound even when autovacuum is otherwise disabled.
         </para>
  
         <para>
          Vacuum also allows removal of old files from the
!         <filename>pg_xact</> subdirectory, which is why the default
!         is a relatively low 200 million transactions.
          This parameter can only be set at server start, but the setting
          can be reduced for individual tables by
          changing table storage parameters.
--- 6025,6038 ----
          Specifies the maximum age (in transactions) that a table's
          <structname>pg_class</>.<structfield>relfrozenxid</> field can
          attain before a <command>VACUUM</> operation is forced
!         to shrink <literal>pg_clog</>.
!         Note that the system will launch autovacuum processes for this purpose
!         even when autovacuum is otherwise disabled.
         </para>
  
         <para>
          Vacuum also allows removal of old files from the
!         <filename>pg_xact</> subdirectory.
          This parameter can only be set at server start, but the setting
          can be reduced for individual tables by
          changing table storage parameters.
*************** COPY postgres_log FROM '/full/path/to/lo
*** 6042,6048 ****
       </varlistentry>
  
       <varlistentry id="guc-autovacuum-multixact-freeze-max-age" xreflabel="autovacuum_multixact_freeze_max_age">
!       <term><varname>autovacuum_multixact_freeze_max_age</varname> (<type>integer</type>)
        <indexterm>
         <primary><varname>autovacuum_multixact_freeze_max_age</varname> configuration parameter</primary>
        </indexterm>
--- 6042,6048 ----
       </varlistentry>
  
       <varlistentry id="guc-autovacuum-multixact-freeze-max-age" xreflabel="autovacuum_multixact_freeze_max_age">
!       <term><varname>autovacuum_multixact_freeze_max_age</varname> (<type>integer 64</type>)
        <indexterm>
         <primary><varname>autovacuum_multixact_freeze_max_age</varname> configuration parameter</primary>
        </indexterm>
*************** COPY postgres_log FROM '/full/path/to/lo
*** 6051,6067 ****
         <para>
          Specifies the maximum age (in multixacts) that a table's
          <structname>pg_class</>.<structfield>relminmxid</> field can
!         attain before a <command>VACUUM</> operation is forced to
!         prevent multixact ID wraparound within the table.
!         Note that the system will launch autovacuum processes to
!         prevent wraparound even when autovacuum is otherwise disabled.
         </para>
  
         <para>
-         Vacuuming multixacts also allows removal of old files from the
-         <filename>pg_multixact/members</> and <filename>pg_multixact/offsets</>
-         subdirectories, which is why the default is a relatively low
-         400 million multixacts.
          This parameter can only be set at server start, but the setting can
          be reduced for individual tables by changing table storage parameters.
          For more information see <xref linkend="vacuum-for-multixact-wraparound">.
--- 6051,6063 ----
         <para>
          Specifies the maximum age (in multixacts) that a table's
          <structname>pg_class</>.<structfield>relminmxid</> field can
!         attain before a <command>VACUUM</> operation is forced
!         to shrink <literal>pg_multixact</>.
!         Note that the system will launch autovacuum processes for this
!         purpose even when autovacuum is otherwise disabled.
         </para>
  
         <para>
          This parameter can only be set at server start, but the setting can
          be reduced for individual tables by changing table storage parameters.
          For more information see <xref linkend="vacuum-for-multixact-wraparound">.
*************** COPY postgres_log FROM '/full/path/to/lo
*** 6527,6533 ****
       </varlistentry>
  
       <varlistentry id="guc-vacuum-freeze-table-age" xreflabel="vacuum_freeze_table_age">
!       <term><varname>vacuum_freeze_table_age</varname> (<type>integer</type>)
        <indexterm>
         <primary><varname>vacuum_freeze_table_age</> configuration parameter</primary>
        </indexterm>
--- 6523,6529 ----
       </varlistentry>
  
       <varlistentry id="guc-vacuum-freeze-table-age" xreflabel="vacuum_freeze_table_age">
!       <term><varname>vacuum_freeze_table_age</varname> (<type>integer 64</type>)
        <indexterm>
         <primary><varname>vacuum_freeze_table_age</> configuration parameter</primary>
        </indexterm>
*************** COPY postgres_log FROM '/full/path/to/lo
*** 6540,6558 ****
          a regular <command>VACUUM</> in that it visits every page that might
          contain unfrozen XIDs or MXIDs, not just those that might contain dead
          tuples.  The default is 150 million transactions.  Although users can
!         set this value anywhere from zero to two billions, <command>VACUUM</>
          will silently limit the effective value to 95% of
          <xref linkend="guc-autovacuum-freeze-max-age">, so that a
          periodical manual <command>VACUUM</> has a chance to run before an
!         anti-wraparound autovacuum is launched for the table. For more
!         information see
          <xref linkend="vacuum-for-wraparound">.
         </para>
        </listitem>
       </varlistentry>
  
       <varlistentry id="guc-vacuum-freeze-min-age" xreflabel="vacuum_freeze_min_age">
!       <term><varname>vacuum_freeze_min_age</varname> (<type>integer</type>)
        <indexterm>
         <primary><varname>vacuum_freeze_min_age</> configuration parameter</primary>
        </indexterm>
--- 6536,6554 ----
          a regular <command>VACUUM</> in that it visits every page that might
          contain unfrozen XIDs or MXIDs, not just those that might contain dead
          tuples.  The default is 150 million transactions.  Although users can
!         set this value anywhere from zero to 2^63 - 1, <command>VACUUM</>
          will silently limit the effective value to 95% of
          <xref linkend="guc-autovacuum-freeze-max-age">, so that a
          periodical manual <command>VACUUM</> has a chance to run before an
!         autovacuum to shrink <literal>pg_clog</> and <literal>pg_multixact</>
!         is launched for the table. For more information see
          <xref linkend="vacuum-for-wraparound">.
         </para>
        </listitem>
       </varlistentry>
  
       <varlistentry id="guc-vacuum-freeze-min-age" xreflabel="vacuum_freeze_min_age">
!       <term><varname>vacuum_freeze_min_age</varname> (<type>integer 64</type>)
        <indexterm>
         <primary><varname>vacuum_freeze_min_age</> configuration parameter</primary>
        </indexterm>
*************** COPY postgres_log FROM '/full/path/to/lo
*** 6563,6569 ****
          should use to decide whether to freeze row versions
          while scanning a table.
          The default is 50 million transactions.  Although
!         users can set this value anywhere from zero to one billion,
          <command>VACUUM</> will silently limit the effective value to half
          the value of <xref linkend="guc-autovacuum-freeze-max-age">, so
          that there is not an unreasonably short time between forced
--- 6559,6565 ----
          should use to decide whether to freeze row versions
          while scanning a table.
          The default is 50 million transactions.  Although
!         users can set this value anywhere from zero to 2^63 - 1,
          <command>VACUUM</> will silently limit the effective value to half
          the value of <xref linkend="guc-autovacuum-freeze-max-age">, so
          that there is not an unreasonably short time between forced
*************** COPY postgres_log FROM '/full/path/to/lo
*** 6574,6580 ****
       </varlistentry>
  
       <varlistentry id="guc-vacuum-multixact-freeze-table-age" xreflabel="vacuum_multixact_freeze_table_age">
!       <term><varname>vacuum_multixact_freeze_table_age</varname> (<type>integer</type>)
        <indexterm>
         <primary><varname>vacuum_multixact_freeze_table_age</> configuration parameter</primary>
        </indexterm>
--- 6570,6576 ----
       </varlistentry>
  
       <varlistentry id="guc-vacuum-multixact-freeze-table-age" xreflabel="vacuum_multixact_freeze_table_age">
!       <term><varname>vacuum_multixact_freeze_table_age</varname> (<type>integer 64</type>)
        <indexterm>
         <primary><varname>vacuum_multixact_freeze_table_age</> configuration parameter</primary>
        </indexterm>
*************** COPY postgres_log FROM '/full/path/to/lo
*** 6587,6604 ****
          a regular <command>VACUUM</> in that it visits every page that might
          contain unfrozen XIDs or MXIDs, not just those that might contain dead
          tuples.  The default is 150 million multixacts.
!         Although users can set this value anywhere from zero to two billions,
          <command>VACUUM</> will silently limit the effective value to 95% of
          <xref linkend="guc-autovacuum-multixact-freeze-max-age">, so that a
          periodical manual <command>VACUUM</> has a chance to run before an
!         anti-wraparound is launched for the table.
          For more information see <xref linkend="vacuum-for-multixact-wraparound">.
         </para>
        </listitem>
       </varlistentry>
  
       <varlistentry id="guc-vacuum-multixact-freeze-min-age" xreflabel="vacuum_multixact_freeze_min_age">
!       <term><varname>vacuum_multixact_freeze_min_age</varname> (<type>integer</type>)
        <indexterm>
         <primary><varname>vacuum_multixact_freeze_min_age</> configuration parameter</primary>
        </indexterm>
--- 6583,6601 ----
          a regular <command>VACUUM</> in that it visits every page that might
          contain unfrozen XIDs or MXIDs, not just those that might contain dead
          tuples.  The default is 150 million multixacts.
!         Although users can set this value anywhere from zero to 2^63 - 1,
          <command>VACUUM</> will silently limit the effective value to 95% of
          <xref linkend="guc-autovacuum-multixact-freeze-max-age">, so that a
          periodical manual <command>VACUUM</> has a chance to run before an
!         autovacuum to shrink <literal>pg_clog</> and <literal>pg_multixact</>
!         is launched for the table.
          For more information see <xref linkend="vacuum-for-multixact-wraparound">.
         </para>
        </listitem>
       </varlistentry>
  
       <varlistentry id="guc-vacuum-multixact-freeze-min-age" xreflabel="vacuum_multixact_freeze_min_age">
!       <term><varname>vacuum_multixact_freeze_min_age</varname> (<type>integer 64</type>)
        <indexterm>
         <primary><varname>vacuum_multixact_freeze_min_age</> configuration parameter</primary>
        </indexterm>
*************** COPY postgres_log FROM '/full/path/to/lo
*** 6609,6615 ****
          should use to decide whether to replace multixact IDs with a newer
          transaction ID or multixact ID while scanning a table.  The default
          is 5 million multixacts.
!         Although users can set this value anywhere from zero to one billion,
          <command>VACUUM</> will silently limit the effective value to half
          the value of <xref linkend="guc-autovacuum-multixact-freeze-max-age">,
          so that there is not an unreasonably short time between forced
--- 6606,6612 ----
          should use to decide whether to replace multixact IDs with a newer
          transaction ID or multixact ID while scanning a table.  The default
          is 5 million multixacts.
!         Although users can set this value anywhere from zero to 2^63 - 1,
          <command>VACUUM</> will silently limit the effective value to half
          the value of <xref linkend="guc-autovacuum-multixact-freeze-max-age">,
          so that there is not an unreasonably short time between forced
